;blockhead.asm

.MEMORYMAP
DEFAULTSLOT 0
SLOTSIZE $8000
SLOT 0 $0000
.ENDME

.ROMBANKMAP
BANKSTOTAL 1
BANKSIZE $8000
BANKS 1
.ENDRO

.sdsctag 1.00,"blockhead","?","proppy"

.bank 0 slot 0

.include "blockhead.inc"
.include "data.inc"

.include "org.inc"

Main:
  ld sp, $dff0    ; init stack
InitVdpRegs:
  ld hl, VdpRegs
  ld b, EndVdpRegs - VdpRegs
  ld c, $bf
  otir

LoadPalettes:

LoadBgPal
  ld de, $c000
  ld hl, BgPal
  ld b, EndBgPal - BgPal
  call VdpCopy

LoadStreumonPal:
  ld de, $c010    ; VdpCommand : CRAM write at $0010
  ld hl, SpritePal
  ld b, EndSpritePal - SpritePal
  call VdpCopy

LoadHeroPal:
  ld de, $c014
  rst $10
  ld hl, HeroPal
  inc hl
  ld a, (hl)
  out ($be), a
  ld de, $c018
  rst $10
  inc hl
  ld a, (hl)
  out ($be), a
  ld de, $c01c
  rst $10
  inc hl
  ld a, (hl)
  out ($be), a

OffsetTile:
  ld de, $4000 + $20
  rst $10
LoadStreumonTiles:
  ld b, $04
  ld c, $00
  ld e, $00 ; remap color to 0
  -:
    push bc
      ld hl, StreumonTiles + $40
      call LoadTile2Bpp16x16Sprite4Stripped
      ld hl, StreumonTiles + $60
      call LoadTile2Bpp16x16Sprite4Stripped
      ld hl, StreumonTiles
      call LoadTile2Bpp16x16Sprite4Stripped
      ld hl, StreumonTiles + $20
      call LoadTile2Bpp16x16Sprite4Stripped
      ld hl, SplashTiles
      call LoadTile2Bpp16x16Sprite4Stripped
      ld hl, SplashTiles + $20
      call LoadTile2Bpp16x16Sprite4Stripped
      ld hl, SplashTiles + $40
      call LoadTile2Bpp16x16Sprite4Stripped
      ld hl, SplashTiles + $60
      call LoadTile2Bpp16x16Sprite4Stripped
    pop bc
    inc c
  djnz -

LoadHeroTiles:
  ld c, $01
  ld hl, HeroTiles
  call LoadTile2Bpp16x16Sprite2Stripped
  ld hl, HeroTiles + $20
  call LoadTile2Bpp16x16Sprite2Stripped
LoadBgTiles:
  LoadBgRockTiles:
    ld hl, BgRockTiles
    ld b, (EndBgRockTiles - (BgRockTiles))/$10
    ld c, $00
    call LoadTile2Bppv2
  LoadBgEtoileTiles:
    ld hl, BgEtoileTiles
    ld b, (EndBgEtoileTiles - BgEtoileTiles)/SizeOf2BppTile
    ld c, $01
    call LoadTile2Bppv2
  LoadBgGalaxyTiles:
    ld hl, BgGalaxyTiles
    ld b, (EndBgGalaxyTiles - BgGalaxyTiles)/SizeOf2BppTile
    ld c, $01
    call LoadTile2Bppv2
  LoadBgMartianTiles:
    ld e, $ff
    ld hl, MartianTiles
    ld b, (EndMartianTiles - MartianTiles)/SizeOf2BppTile
    ld c, $02
    call LoadTile2Bppv2
  LoadBgRockMap1:
    ld hl, $7800
    ld ix, BgRockMap
    ld d, $89 ; base tile
    ld e, $00 ; flip
    ld c, $06 ; w
    ld b, $14 ; h
    call LoadTileMap1
  LoadBgRockMap2:
    ld hl, $79b4
    ld ix, BgRockMap
    ld d, $89 ; base tile
    ld e, $02 ; flip
    ld c, $06 ; w
    ld b, $14 ; h
    call LoadTileMapRev

  LoadBgEtoileMap1:
      ld b, EndBgEtoileMetaMap - BgEtoileMetaMap
      ld c, $00

      -:
      push bc

        ld hl, BgEtoileMetaMap
        ld b, $00
        add hl, bc
        ld a, (hl)
        ld e, a
        inc hl
        ld a, (hl)
        and $0f
        ld d, a

        ld hl, $780c
        add hl, de

        ld ix, BgEtoileMap
        ld d, $c2 ; base tile
        ld e, $00 ; flip
        ld c, $08 ; w
        ld b, $04 ; h

        ld a, (hl)
        and $10
        jp nz, +
        call LoadTileMap1
        jp ++
        +:
        call LoadTileMapRev
        ++:
      pop bc
      inc c
      inc c
      dec b
      djnz -


      ld b, EngBgGalaxyMetaMap - BgGalaxyMetaMap
      ld c, $00

      -:
      push bc

        ld hl, BgGalaxyMetaMap
        ld b, $00
        add hl, bc
        ld a, (hl)
        ld e, a
        inc hl
        ld a, (hl)
        and $0f
        ld d, a

        ld hl, $780c
        add hl, de

        ld ix, BgGalaxyMap
        ld d, $c6 ; base tile
        ld e, $00 ; flip
        ld c, $04 ; w
        ld b, $02 ; h

        ld a, (hl)
        and $10
        jp nz, +
        call LoadTileMap1
        jp ++
        +:
        call LoadTileMapRev
        ++:
      pop bc
      inc c
      inc c
      dec b
      djnz -

  LoadMartianMap:
    ld a, $00
    ld (martianMood), a

InitBlock:
  ld hl, tiedBlock
  ld (hl), $00
  ld de, tiedBlock
  ld bc, TiedCount - 1
  ldir
  ld hl, stateBlock
  ld (hl), $00
  ld de, stateBlock + 1
  ld bc, BlockCount - 1
  ldir ; memset 0
  ld hl, yBlock
  ld (hl), $00
  ld de, yBlock + 1
  ld bc, BlockCount - 1
  ldir
  ld hl, xBlock
  ld (hl), $00
  ld de, xBlock + 1
  ld bc, BlockCount - 1
  ldir
  ld hl, nTile
  ld (hl), $00
  ld de, nTile + 1
  ld bc, BlockCount - 1
  ldir

InitTestBlock:
  ld c, $08
  -:
    ld b, BlockState
    ld a, BlockStateUp
    ld (bc), a
    ld b, BlockYPos
    ld a, $20
    ld (bc), a
    ld b, BlockXPos
    ld a, R
    rra
    add a, $30
    and $f0
    ld (bc), a
    ld b, BlockNTile
    ld a, R
    and $03
    inc a
    ;ld a, c
    dec a
    rla
    rla
    rla
    rla
    rla
    inc a
    ld (bc), a
    ld b, BlockFrame
    ld a, c
    ld (bc), a

  dec c
  jp nz, -

InitTied:
  xor a
  ld (tiedIndex), a
InitInput:
  ld a, $ff
  ld (input), a
InitTimeout:
  xor a
  ld (timeout), a
InitFrame:
  xor a
  ld (frame), a
InitPlayer:
  ld c, $00
  ld b, BlockXPos
  ld a, $20
  ld (bc), a
  ld b, BlockYPos
  ld a, $b0
  ld (bc), a
  ld b, BlockNTile
  ld a, $81
  ld (bc), a
  ld b, BlockFrame
  ld a, $10
  ld (bc), a

EnableDisplay:
  ld hl, $8160
  rst $08
Game:

WaitBeginVBlank:
;  ld c, $c0
  ld c, $f3

  call WaitVCount

  call MirrorSAT

  UpdateFrame:
  ld a, (frame)
  cp $00
  jp nz, +
  ld a, 226
  +:
  dec a
  dec a
  ld (frame), a
  out ($bf), a
  ld a, $89
  out ($bf), a

;  jp +
  UpdateMartian:
    ld de, MartianMiniMap
    ld a, (martianMood)
    add a, e
    ld e, a
    ld hl, $7800 + 64 * 12 + 60
    ld  c, $ce ;base tile
    call LoadMiniMap16x16Sprite

    ld a, (frame)
    and $1f
    jp nz, +
      ld a, (martianMood)
      xor $02
      ld (martianMood), a
    +:

  UpdateBlock:
    ld b, BlockState
    ld c, $10
    ld h, $01
    ld l, $00
    -:
      ld b, BlockState
      ld a, (bc)
      cp BlockStateNone
      jp z, NextBlock
      cp BlockStateDown
      jp z, UpdateStateDown
      cp BlockStateTie
      jp z, UpdateStateTie
      cp BlockStateUp
      jp z, UpdateStateUp
      cp BlockStateSplash
      jp z, UpdateStateSplash
      jp NextBlock ; should never happen
      UpdateStateDown:
        ld b, BlockYPos
        ld a, (bc)
        inc a
        cp $c0
        jp c, +
           xor a
        +:
        ld d, a
      CollideX:
        ld b, BlockXPos
        ld a, (bc)
        ld b, a
        push de
          call GetTied
          ld d, BlockXPos
          ld e, a
          ld a, (de)
        pop de
        sub b
        cp $80
        jp c, +
           neg
           ;ld e, a
           ;ld a, $ff
           ;sub e
        +:
        cp $0f
        jp nc, +
      CollideY:
        push de
          call GetTied
          ld d, BlockYPos
          ld e, a
          ld a, (de)
        pop de
        sub d
        cp $08
        jp nz, +
          StateDownToTie:
            push de
            call GetTied
            ld d, BlockYPos
            ld e, a
            ld a, (de)
            pop de

            sub $10
            ld b, BlockYPos
            ld (bc), a

            ld b, BlockState
            ld a, BlockStateTie
            ld (bc), a
            push de
            call PushTied
            pop de
            jp ++
        +:
        ld b, BlockYPos
        ld a, d
        ld (bc), a
        ++:
        call RenderBlock
        jp NextBlock
      UpdateStateTie:
        ld a, (playerXPos)
        ld b, BlockXPos
        ld (bc), a
        call RenderBlock
        jp NextBlock
      UpdateStateUp:
        TestColWithFallingDownBlock:
        ld b, BlockYPos
        ld a, (bc)
        dec a
        jp nz, +
        StateUpToDown:
          ld b, BlockState
          ld a, BlockStateDown
          ld (bc), a
          ld b, BlockNTile
          ld a, (bc)
          xor $08
          ld (bc), a
          ld b, BlockYPos
          ld a, 0
        +:
        ld (bc), a
        call ColTestBlockUp
        call RenderBlock
        jp NextBlock

      UpdateStateSplash:
        call RenderBlockSplash
        jp NextBlock
      RenderBlockSplash:
        push hl
        push bc
        call SetCol2Block
        ld b, BlockXPos
        ld a, (bc)
        ld h, a
        ld b, BlockYPos
        ld a, (bc)
        ld l, a
        ld b, BlockFrame
        ld a, (bc)
        dec a
        jp nz, +
           ;next frame
           ld b, BlockNTile
           ld a, (bc)
           push af
             add a, $04
             and $0f
             cp $01
             jp nz, ++
             call Recycle
             ;clean me
             pop af
             pop bc
             pop hl
             ret
             ++:
             ld  d, a
           pop af
           and $f0
           or d
           ld (bc), a
           ld b, BlockFrame
           ld a, $08
        +:
        ld (bc), a
        +++:
        ld b, BlockNTile
        ld a, (bc)
        ld d, a
        ld a, c
        add a, a
        add a, a
        ld e, a
        call SpriteSet16x16Mirror
        pop bc
        pop hl
        ret
      RenderBlock:
        push hl
        push bc
        call SetCol2Block
        ld b, BlockXPos
        ld a, (bc)
        ld h, a
        ld b, BlockYPos
        ld a, (bc)
        ld l, a
        ld b, BlockFrame
        ld a, (bc)
        dec a
        jp nz, +
           ;next frame
           ld b, BlockNTile
           ld a, (bc)
           xor 4
           ld (bc), a
           ld b, BlockFrame
           ld a, $10
        +:
        ld (bc), a
        ld b, BlockNTile
        ld a, (bc)
        ld d, a

        ld a, c
        add a, a
        add a, a
        ld e, a
        call SpriteSet16x16Mirror
        pop bc
        pop hl
        ret
    NextBlock:
      dec c
      jp nz, -
  EndUpdateBlock:
  UpdatePlayer:
    UpdateInput:
      in a, ($dc)
      ld d, a

      and $04
      jp nz, +
         ld c, $ff
      +:
      ld a, d
      and $08
      jp nz, +
         ld c, $01
      +:
      ld a, (playerXPos)
      add a, c
      ld (playerXPos), a

      ld a, (timeout)
      cp $00
      jp nz, +
      ld a, d
      and $01
        jp nz, ++
          call GetTied
          cp $00
          jp z, ++
             ld c, a
             ld b, BlockState
             ld a, BlockStateUp
             ld (bc), a
             ld b, BlockNTile
             ld a, (bc)
             xor $08
             ld (bc), a
             call PopTied
             ld a, $00
             ld (tiedBlock), a
             ld a, $10 + $01
      +:
      dec a
      ld (timeout), a
      ++:

    UpdatePlayerPos:
  EndUpdatePlayer:
  RenderPlayer:
    ld c, $00
    call RenderBlock

  EndRenderPlayer:
  jp Game

End:
-
jp -

; c entity number
PushTied:
  ld a, (tiedIndex)
  inc a
  ld (tiedIndex), a
  cp $10
  GameOver:
    jp z, End
  ld d, BlockTied
  ld e, a
  ld a, c
  ld (de), a
  ret
; c entity number
PopTied:
  ld a, (tiedIndex)
  ld d, BlockTied
  ld e, a
  xor a
  ld (de), a
  ld a, e
  dec a
  ld (tiedIndex), a
  Assert:
    cp $ff
    jp z, End
  ret
GetTied:
  ld a, (tiedIndex)
  ld d, BlockTied
  ld e, a
  ld a, (de)
  ret
SetCol2Block:
  ; c entity number
  push de
  ld b, Block2Col
  ld a, (bc)
  ld d, Col2Block
  ld e, a
  xor a
  ld (de), a

  ld b, BlockXPos
  ld a, (bc)
  rra
  rra
  rra
  rra
  and $0f
  ld e, a
  ld b, BlockYPos
  ld a, (bc)
  and $f0
  or e
  ld e, a

  ld d, Col2Block
  ld a, (de)
  cp $00
  jp z, +
;    push de
;      ld e, a
;      call Collide
;    pop de
  +:
  ld d, Col2Block
  ld a, c
  ld (de), a
  ld b, Block2Col
  ld a, e
  ld (bc), a

  pop de
  ret

ColTestBlockUp:
 ld e, $08
 -:
 call  newCollide
; cp $00
; ret nz
 dec e
 jp nz, -
 xor a
 ret

newCollide:
newCollideX:
         ld a, c
         cp e
         jp nz, +
         xor a
         ret
         +:
         ld b, BlockXPos
         ld a, (bc)

         ld b, a

         ld d, BlockXPos
         ld a, (de)

         sub b
         cp $80
         jp c, +
           neg
         +:
         cp $0f
         jp nc, +
       newCollideY:

         ld d, BlockYPos
         ld a, (de)

         ld d, a

         ld b, BlockYPos
         ld a, (bc)

         sub d
         ;cp $80
         ;jp c, +
         ;  neg
         ;+:
         cp $0f
         jp nc, +
;         ld b, BlockYPos
;         ld a, (bc)

;         ld b, a

;         ld d, BlockYPos
;         ld a, (de)
;         sub b
;         cp $10
         ;jp nc, +
            call Collide
            ld a, $01
            ret
        +:
        xor a
        ret

Collide:
; c current e collide with
; check if state ok
;  ld b, BlockState
;  ld a, (bc)
;  cp BlockStateUp
;  jp nz, +
  ld d, BlockState
  ld a, (de)
  cp BlockStateDown
  jp nz, +
;        jp ++
        ld d, BlockNTile
        ld a, (de)
        and $e0
        ld d, a
        ld b, BlockNTile
        ld a, (bc)
        and $e0
        cp d
        jp nz, ++
        ;+:
        ld a, c
        call StateToSplash
        ld a, e
        call StateToSplash
        ld a, $01
       ;set nz flag
        ret

       ++:
       ld a, c
       call StateToDown
       ld a, $01
       ret
  +:
  xor a
  ret

StateToSplash:
  push bc
    ld b, BlockState
    ld c, a
    ld a, BlockStateSplash
    ld (bc), a
    ld b, BlockNTile
    ld a, (bc)
    xor $10
    and $f0
    or  $01
    ld (bc),a
    ld b, BlockFrame
    ld a, $08
    ld (bc), a

    ld a, $04
    ld (martianMood), a
  pop bc
  ret
StateToDown:
  push bc
    ; func me
    ld b, BlockState
    ld c, a
    ld a, BlockStateDown
    ld (bc), a
    ld b, BlockNTile
    ld a, (bc)
    xor $08
    ld (bc),a
    ld b, BlockYPos
    push de
    ld d, BlockYPos
    ld a, (de)
    add a, $10
    pop de
    ;ld a, (bc)
    ;buggy fixed
    inc a
    ;inc a
    ld (bc), a
  pop bc
  ret

Recycle:
  push af
  push bc
     ld b, BlockState
     ld a, BlockStateDown
     ld (bc), a
     ld b, BlockNTile
     ld a, (bc)
     and $e7
     or $08
     ld (bc), a
     ld b, BlockYPos
     ld a, 0
     ld (bc), a
     ld b, BlockXPos
     ld a, R
     rra
     add a, $30
     and $f0
     ld (bc), a
  pop bc
  pop af
  ret

  LoadMiniMap16x16Sprite:
  ;  de point to data
  ;  hl point to vram
  ;  h y position
  ;  l x position
  ; ---x xxxx
  ; ---y yyyy


  ; ---- -yyy yyxx xxx-

  jp +
  ld a, l
  and $1f
  rla
  ld l, a

  ld a, h
  rra
  rra
  push af
    and $c0
    or l
    ld l, a
  pop af
  and $07
  or  $78
  ld h, a

  +:
  rst $08
  ld a, (de)
  call LoadMiniMap
  push bc
    ld bc, $40
    add hl, bc
  pop bc
  rst $08
  inc de
  ld a, (de)
  call LoadMiniMap
  ret

  LoadMiniMap:
    ld b, a

    and $f0
    rra
    rra
    rra
    rra
    call LoadNibbleToMap

    ld a, b
    and $0f
    call LoadNibbleToMap
    ret

   LoadNibbleToMap:
    push af
    and $07

;      ld a, $01
      add a, c
      out ($be), a
    pop af
    and $08
    rra
    rra
      out ($be), a
    ret

.include "gfxFunc.inc"
.include "gfx.inc"
